package com.yunfeiyun.agmp.common.framework.manager;

import com.yunfeiyun.agmp.common.constant.Constants;
import com.yunfeiyun.agmp.common.core.domain.entity.SysLoginLog;
import com.yunfeiyun.agmp.common.framework.web.service.ISysLoginLogService;
import com.yunfeiyun.agmp.common.framework.web.service.ISysOperLogService;
import com.yunfeiyun.agmp.common.core.domain.model.IBaseLoginLog;
import com.yunfeiyun.agmp.common.core.domain.model.IBaseOperLog;
import com.yunfeiyun.agmp.common.utils.LogUtils;
import com.yunfeiyun.agmp.common.utils.ServletUtils;
import com.yunfeiyun.agmp.common.utils.StringUtils;
import com.yunfeiyun.agmp.common.utils.ip.AddressUtils;
import com.yunfeiyun.agmp.common.utils.ip.IpUtils;
import com.yunfeiyun.agmp.common.utils.spring.SpringUtils;
import eu.bitwalker.useragentutils.UserAgent;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import java.util.TimerTask;

/**
 * 异步工厂（产生任务用）
 * 
 * @author 杨晓辉
 */
public class AsyncFactory
{
    private static final Logger sys_user_logger = LoggerFactory.getLogger("sys-user");

    /**
     * 记录登录信息
     * 
     * @param username 用户名
     * @param status 状态
     * @param message 消息
     * @param args 列表
     * @return 任务task
     */
    public static TimerTask recordLogininfor(final String username, final String status, final String message, final Object... args)
    {
        final UserAgent userAgent = UserAgent.parseUserAgentString(ServletUtils.getRequest().getHeader("User-Agent"));
        final String ip = IpUtils.getIpAddr();
        return new TimerTask()
        {
            @Override
            public void run()
            {
                String address = AddressUtils.getRealAddressByIP(ip);
                StringBuilder s = new StringBuilder();
                s.append(LogUtils.getBlock(ip));
                s.append(address);
                s.append(LogUtils.getBlock(username));
                s.append(LogUtils.getBlock(status));
                s.append(LogUtils.getBlock(message));
                // 打印信息到日志
                sys_user_logger.info(s.toString(), args);
                // 获取客户端操作系统
                String os = userAgent.getOperatingSystem().getName();
                // 获取客户端浏览器
                String browser = userAgent.getBrowser().getName();
                // 封装对象
                IBaseLoginLog loginLog = new SysLoginLog();
                loginLog.setLoggLoginname(username);
                loginLog.setIpaddr(ip);
                loginLog.setLoginLocation(address);
                loginLog.setLoginBrowser(browser);
                loginLog.setLoginOs(os);
                loginLog.setLoginMsg(message);
                // 日志状态
                if (StringUtils.equalsAny(status, Constants.LOGIN_SUCCESS, Constants.LOGOUT, Constants.REGISTER))
                {
                    loginLog.setLoginStatus(Constants.SUCCESS);
                }
                else if (Constants.LOGIN_FAIL.equals(status))
                {
                    loginLog.setLoginStatus(Constants.FAIL);
                }
                SpringUtils.getBean(ISysLoginLogService.class).insertLoginLog(loginLog);
            }
        };
    }




    /**
     * 操作日志记录
     * 
     * @param operLog 操作日志信息
     * @return 任务task
     */
    public static TimerTask recordOper(final IBaseOperLog operLog)
    {
        return new TimerTask()
        {
            @Override
            public void run()
            {
                // 远程查询操作地点
                operLog.setOperLocation(AddressUtils.getRealAddressByIP(operLog.getOperIp()));
                SpringUtils.getBean(ISysOperLogService.class).insertOperlog(operLog);
            }
        };
    }
}
